//
//  ViewController.m
//  PateFun
//
//  Created by JX on 16/5/5.
//  Copyright © 2016年 JX. All rights reserved.
//

#import "ViewController.h"

typedef int (^Block) (int a, int b);

@interface ViewController ()<UITextFieldDelegate>

@property (weak, nonatomic) IBOutlet UITextField *textFiled;

@property (weak, nonatomic) IBOutlet UILabel *label;

@property (nonatomic, copy) NSString *string;

@property (nonatomic, copy) Block block;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(changeAction:) name:UITextFieldTextDidChangeNotification object:nil];
    
    self.textFiled.delegate = self;
    
    self.block  = ^(int a, int b){
        
        return a + b;
    };
}

- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string
{
    
    NSCharacterSet *jx;
    
    jx = [[NSCharacterSet characterSetWithCharactersInString:@"0123456789\n"] invertedSet];
    
    NSString *filtered = [[string componentsSeparatedByCharactersInSet:jx]componentsJoinedByString:@""];
    
     BOOL change = [string isEqualToString:filtered];
    
    NSString * toBeString = [textField.text stringByReplacingCharactersInRange:range withString:string];
    
    if (self.textFiled == textField)
    {
        if ([toBeString length] > 6) {
            textField.text = [toBeString substringToIndex:6];
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:nil message:@"超过最大字数不能输入了" delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil, nil];
            [alert show];
            return NO;
        }
    }
    
    
    return change;
    
}

- (void)changeAction:(NSNotification *)ification
{
    
    
    
    
    UITextField *textFiled = ification.object;
    
    self.string = textFiled.text;
    
    if (self.string.length != 0) {
        
        int b = [self.string intValue];
        
       int c = self.block(0, b);
        
        self.label.text = [NSString stringWithFormat:@"%d", c];
    }
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
